diff --git a/os/core/src/aos_main.cpp b/os/core/src/aos_main.cpp
index 9141f09..8d3e80b 100644
--- a/os/core/src/aos_main.cpp
+++ b/os/core/src/aos_main.cpp
@@ -111,7 +111,7 @@ AMIROOS_CFG_MAIN_EXTRA_STATIC_VARIABLES
 static inline void _unexpectedEventError(const eventmask_t mask, const eventflags_t flags)
 {
 #if (AMIROOS_CFG_DBG == true)
-  aosprintf("unexpected/unknown event received. mask: 0x%08X; flags: 0x%08X\n", mask, flags);
+  aosprintf("CTRL: unexpected/unknown event received. mask: 0x%08X; flags: 0x%08X\n", mask, flags);
 #else
   (void)(mask);
   (void)(flags);
@@ -366,7 +366,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
     if (flags.wfe) {
       // wait for any event to occur
       aosDbgPrintf("WFE...");
-      eventmask = chEvtWaitAnyTimeout(ALL_EVENTS, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT));
+      eventmask = chEvtWaitAnyTimeout(ALL_EVENTS, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT));
       aosDbgPrintf("\t0x%08X", eventmask);
     } else {
       aosDbgPrintf("WFE skipped");
@@ -483,13 +483,13 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
           flags.wfe_next = false;
 #else
           // set the timeout timer
-          chVTSet(&timerTimeout, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
+          chVTSet(&timerTimeout, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
           // proceed
           stage = STAGE_3_3_WAITFORFIRSTID;
 #endif
 #else
           // set the timeout timer
-          chVTSet(&timerTimeout, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
+          chVTSet(&timerTimeout, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
 #endif
         }
 
@@ -515,7 +515,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
             flags.wfe_next = false;
 #else
             // set the timeout timer
-            chVTSet(&timerTimeout, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
+            chVTSet(&timerTimeout, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
             // proceed
             stage = STAGE_3_3_WAITFORFIRSTID;
 #endif
@@ -556,7 +556,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
           stage = STAGE_3_3_WAITFORID;
 #else
           // set the delay timer so the UP signal is activated later
-          chVTSet(&timerDelay, TIME_US2I(AMIROOS_CFG_SSSP_SIGNALDELAY), _ssspTimerCallback, &eventSourceDelay);
+          chVTSet(&timerDelay, chTimeUS2I(AMIROOS_CFG_SSSP_SIGNALDELAY), _ssspTimerCallback, &eventSourceDelay);
 #endif
         }
 
@@ -597,7 +597,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
               // store received ID
               lastid = _deserialize(canRxFrame.data8, 4);
               // restart timeout timer
-              chVTSet(&timerTimeout, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
+              chVTSet(&timerTimeout, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
               // proceed
               stage = STAGE_3_3_WAITFORIDORSIG;
             } else {
@@ -633,7 +633,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
               // store received ID
               lastid = _deserialize(canRxFrame.data8, 4);
               // restart timeout timer
-              chVTSet(&timerTimeout, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
+              chVTSet(&timerTimeout, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
             } else {
               aosDbgPrintf("ERR: invalid ID\n");
               // abort
@@ -664,7 +664,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
             break;
           }
           // set delay timer
-          chVTSet(&timerDelay, TIME_US2I(AMIROOS_CFG_SSSP_SIGNALDELAY), _ssspTimerCallback, &eventSourceDelay);
+          chVTSet(&timerDelay, chTimeUS2I(AMIROOS_CFG_SSSP_SIGNALDELAY), _ssspTimerCallback, &eventSourceDelay);
         }
 
         // if a delay event occurred
@@ -678,7 +678,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
           aosDbgPrintf("S-\n");
           apalControlGpioSet(&moduleSsspGpioSync, APAL_GPIO_OFF);
           // reset the timeout timer
-          chVTSet(&timerTimeout, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
+          chVTSet(&timerTimeout, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
           chEvtWaitAnyTimeout(eventListenerTimeout.events, TIME_IMMEDIATE);
           eventmask &= ~(eventListenerTimeout.events);
           // proceed
@@ -707,7 +707,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
             aosDbgPrintf("ID (%u)\n", lastid);
 #endif
             // restart timeout timer
-            chVTSet(&timerTimeout, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
+            chVTSet(&timerTimeout, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceTimeout);
             chEvtWaitAnyTimeout(eventListenerTimeout.events, TIME_IMMEDIATE);
             eventmask &= ~(eventListenerTimeout.events);
           }
@@ -728,7 +728,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
           chEvtWaitAnyTimeout(eventListenerTimeout.events, TIME_IMMEDIATE);
           eventmask &= ~(eventListenerTimeout.events);
           //set the delay timer
-          chVTSet(&timerDelay, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceDelay);
+          chVTSet(&timerDelay, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT), _ssspTimerCallback, &eventSourceDelay);
         }
 
         // if a CAN event was received
@@ -809,7 +809,7 @@ aos_shutdown_t _ssspModuleStackInitialization(void)
 
     // apply wfe value for next iteration
     flags.wfe = flags.wfe_next;
-  }
+  } /* end of FSM loop */
   aosDbgPrintf("\n");
 
   // unregister all events (timeout, delay, CAN receive)
@@ -919,7 +919,15 @@ int main(void)
 #endif
 
   /* event associations */
-  chEvtRegisterMask(&aos.events.io, &_eventListenerIO, IOEVENT_MASK);
+#if (AMIROOS_CFG_SSSP_STACK_START == true) && (AMIROOS_CFG_SSSP_STACK_END == true)
+  chEvtRegisterMaskWithFlags(&aos.events.io, &_eventListenerIO, IOEVENT_MASK, MODULE_SSSP_EVENTFLAGS_PD | MODULE_SSSP_EVENTFLAGS_SYNC);
+#elif (AMIROOS_CFG_SSSP_STACK_START == true)
+  chEvtRegisterMaskWithFlags(&aos.events.io, &_eventListenerIO, IOEVENT_MASK, MODULE_SSSP_EVENTFLAGS_PD | MODULE_SSSP_EVENTFLAGS_SYNC | MODULE_SSSP_EVENTFLAGS_UP);
+#elif (AMIROOS_CFG_SSSP_STACK_END == true)
+  chEvtRegisterMaskWithFlags(&aos.events.io, &_eventListenerIO, IOEVENT_MASK, MODULE_SSSP_EVENTFLAGS_PD | MODULE_SSSP_EVENTFLAGS_SYNC | MODULE_SSSP_EVENTFLAGS_DN);
+#else
+  chEvtRegisterMaskWithFlags(&aos.events.io, &_eventListenerIO, IOEVENT_MASK, MODULE_SSSP_EVENTFLAGS_PD | MODULE_SSSP_EVENTFLAGS_SYNC | MODULE_SSSP_EVENTFLAGS_DN | MODULE_SSSP_EVENTFLAGS_UP);
+#endif
   chEvtRegisterMask(&aos.events.os, &_eventListenerOS, OSEVENT_MASK);
 
 #if defined(AMIROOS_CFG_MAIN_INIT_HOOK_5)
@@ -1057,7 +1065,7 @@ int main(void)
 
     aosDbgPrintf("receiving current date/time...\t");
     // receive message
-    if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_US2I(AOS_SYSTEM_SSSP_TIMEOUT)) == MSG_OK) {
+    if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, chTimeUS2I(AOS_SYSTEM_SSSP_TIMEOUT)) == MSG_OK) {
       // validate message
       if (frame.DLC == 8 &&
           frame.RTR == CAN_RTR_DATA &&
@@ -1111,7 +1119,7 @@ int main(void)
   while (shutdown == AOS_SHUTDOWN_NONE) {
     // wait for an event
 #if (AMIROOS_CFG_MAIN_LOOP_TIMEOUT != 0)
-    eventmask = chEvtWaitOneTimeout(ALL_EVENTS, TIME_US2I(AMIROOS_CFG_MAIN_LOOP_TIMEOUT));
+    eventmask = chEvtWaitOneTimeout(ALL_EVENTS, chTimeUS2I(AMIROOS_CFG_MAIN_LOOP_TIMEOUT));
 #else
     eventmask = chEvtWaitOne(ALL_EVENTS);
 #endif
@@ -1243,7 +1251,7 @@ int main(void)
 #endif
 
   // finally hand over to bootloader
-  aosSysShutdownFinal(&moduleIntDriver, shutdown);
+  aosSysShutdownFinal(shutdown);
 
   /*
    * ##########################################################################
diff --git a/os/core/src/aos_shell.c b/os/core/src/aos_shell.c
index 978b477..0d88548 100644
--- a/os/core/src/aos_shell.c
+++ b/os/core/src/aos_shell.c
@@ -1503,7 +1503,7 @@ THD_FUNCTION(aosShellThread, shell)
       default:
       {
         // print an error message
-        chprintf((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, "\nERROR: unknown event received (0x%08X)\n", eventmask);
+        chprintf((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, "\nSHELL: ERROR: unknown event received (0x%08X)\n", eventmask);
         break;
       }
 
diff --git a/os/core/src/aos_system.c b/os/core/src/aos_system.c
index 3e370d8..a3a1aa3 100644
--- a/os/core/src/aos_system.c
+++ b/os/core/src/aos_system.c
@@ -31,7 +31,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /**
  * @brief   Period of the system timer.
  */
-#define SYSTIMER_PERIOD               (TIME_MAX_INTERVAL - CH_CFG_ST_TIMEDELTA)
+#define SYSTIMER_PERIOD               (TIME_MAX_SYSTIME - CH_CFG_ST_TIMEDELTA)
 
 /**
  * @brief   Width of the printable system info text.
@@ -576,47 +576,38 @@ static int _shellcmd_kerneltestcb(BaseSequentialStream* stream, int argc, char*
   (void)argc;
   (void)argv;
 
-  tprio_t prio = chThdGetPriorityX();
-  chThdSetPriority(HIGHPRIO - 5); // some tests increase priorirty by 5, so this is the maximum priority permitted
   msg_t retval = test_execute(stream, &rt_test_suite);
-  chThdSetPriority(prio);
 
   return retval;
 }
 #endif /* AMIROOS_CFG_TESTS_ENABLE == true */
 
 /**
- * @brief   Callback function for the PD signal interrupt.
+ * @brief   Generic callback function for GPIO interrupts.
  *
- * @param[in] extp      Pointer to the interrupt driver object.
- * @param[in] channel   Interrupt channel identifier.
+ * @param[in] args   Pointer to the GPIO pad identifier.
  */
-static void _signalPdCallback(void *args)
+static void _intCallback(void* args)
 {
-  (void)args;
+  aosDbgCheck((args != NULL) && (*((iopadid_t*)args) < sizeof(eventflags_t) * 8));
 
   chSysLockFromISR();
-  chEvtBroadcastFlagsI(&aos.events.io, 0);
+  chEvtBroadcastFlagsI(&aos.events.io, (eventflags_t)1 << *((iopadid_t*)args));
   chSysUnlockFromISR();
 
   return;
 }
 
+#if (AMIROOS_CFG_SSSP_MASTER != true) || defined(__DOXYGEN__)
 /**
  * @brief   Callback function for the Sync signal interrupt.
  *
- * @param[in] extp      Pointer to the interrupt driver object.
- * @param[in] channel   Interrupt channel identifier.
+ * @param[in] args   Pointer to the GPIO pad identifier.
  */
 static void _signalSyncCallback(void *args)
 {
-  (void)args;
+  aosDbgCheck((args != NULL) && (*((iopadid_t*)args) < sizeof(eventflags_t) * 8));
 
-#if (AMIROOS_CFG_SSSP_MASTER == true)
-  chSysLockFromISR();
-  chEvtBroadcastFlagsI(&aos.events.io, 0);
-  chSysUnlockFromISR();
-#else
   apalControlGpioState_t s_state;
   aos_timestamp_t uptime;
 
@@ -644,12 +635,12 @@ static void _signalSyncCallback(void *args)
     }
   }
   // broadcast event
-  chEvtBroadcastFlagsI(&aos.events.io, 0);
+  chEvtBroadcastFlagsI(&aos.events.io, (eventflags_t)1 << *((iopadid_t*)args));
   chSysUnlockFromISR();
-#endif
 
   return;
 }
+#endif
 
 /**
  * @brief   Callback function for the uptime accumulation timer.
@@ -664,7 +655,7 @@ static void _uptimeCallback(void* par)
   // read current time in system ticks
   register const systime_t st = chVTGetSystemTimeX();
   // update the uptime variables
-  _uptime += TIME_I2US(st - _synctime);
+  _uptime += chTimeI2US(chTimeDiffX(_synctime, st));
   _synctime = st;
   // enable the timer again
   chVTSetI(&_systimer, SYSTIMER_PERIOD, &_uptimeCallback, NULL);
@@ -696,12 +687,12 @@ static void _sysSyncTimerCallback(void* par)
     // reconfigure the timer precisely, because the logically falling edge (next interrupt) snychronizes the system time
     _syssynctime += AMIROOS_CFG_SSSP_SYSSYNCPERIOD;
     aosSysGetUptimeX(&uptime);
-    chVTSetI(&_syssynctimer, TIME_US2I(_syssynctime - uptime), _sysSyncTimerCallback, NULL);
+    chVTSetI(&_syssynctimer, chTimeUS2I(_syssynctime - uptime), _sysSyncTimerCallback, NULL);
   }
   // if S was toggled from on to off
   else /* if (s_state == APAL_GPIO_OFF) */ {
     // reconfigure the timer (lazy)
-    chVTSetI(&_syssynctimer, TIME_US2I(AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2), _sysSyncTimerCallback, NULL);
+    chVTSetI(&_syssynctimer, chTimeUS2I(AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2), _sysSyncTimerCallback, NULL);
   }
   chSysUnlockFromISR();
 
@@ -721,10 +712,10 @@ void aosSysInit(const char* shellPrompt)
 void aosSysInit(void)
 #endif
 {
-  // set control thread to maximum priority
+  /* set control thread to maximum priority */
   chThdSetPriority(AOS_THD_CTRLPRIO);
 
-  // set local variables
+  /* set local variables */
   chVTObjectInit(&_systimer);
   _synctime = 0;
   _uptime = 0;
@@ -736,23 +727,41 @@ void aosSysInit(void)
   _syssyncskew = 0.0f;
 #endif
 
-  // set aos configuration
+  /* initialize aos configuration */
   aos.sssp.stage = AOS_SSSP_STARTUP_2_1;
   aos.sssp.moduleId = 0;
   aosIOStreamInit(&aos.iostream);
   chEvtObjectInit(&aos.events.io);
   chEvtObjectInit(&aos.events.os);
 
-  // setup external interrupt system
-  aosIntDriverInit(&moduleIntDriver, moduleIntConfig);
-  chSysLock();
-  palSetPadCallbackI(moduleGpioSysPd.port, moduleGpioSysPd.pad, _signalPdCallback, NULL);
-  palSetPadCallbackI(moduleGpioSysSync.port, moduleGpioSysSync.pad, _signalSyncCallback, NULL);
-  chSysUnlock();
-  aosIntDriverStart(&moduleIntDriver);
+  /* interrupt setup */
+  // PD signal
+  palSetPadCallback(moduleSsspGpioPd.gpio->port, moduleSsspGpioPd.gpio->pad, _intCallback, &moduleSsspGpioPd.gpio->pad);
+  palEnablePadEvent(moduleSsspGpioPd.gpio->port, moduleSsspGpioPd.gpio->pad, APAL2CH_EDGE(moduleSsspGpioPd.meta.edge));
+  // SYNC signal
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+  palSetPadCallback(moduleSsspGpioSync.gpio->port, moduleSsspGpioSync.gpio->pad, _intCallback, &moduleSsspGpioSync.gpio->pad);
+#else
+  palSetPadCallback(moduleSsspGpioSync.gpio->port, moduleSsspGpioSync.gpio->pad, _signalSyncCallback, &moduleSsspGpioSync.gpio->pad);
+#endif
+  palEnablePadEvent(moduleSsspGpioSync.gpio->port, moduleSsspGpioSync.gpio->pad, APAL2CH_EDGE(moduleSsspGpioSync.meta.edge));
+#if (AMIROOS_CFG_SSSP_STACK_START != true)
+  // DN signal
+  palSetPadCallback(moduleSsspGpioDn.gpio->port, moduleSsspGpioDn.gpio->pad, _intCallback, &moduleSsspGpioDn.gpio->pad);
+  palEnablePadEvent(moduleSsspGpioDn.gpio->port, moduleSsspGpioDn.gpio->pad, APAL2CH_EDGE(moduleSsspGpioDn.meta.edge));
+#endif
+#if (AMIROOS_CFG_SSSP_STACK_END != true)
+  // UP signal
+  palSetPadCallback(moduleSsspGpioUp.gpio->port, moduleSsspGpioUp.gpio->pad, _intCallback, &moduleSsspGpioUp.gpio->pad);
+  palEnablePadEvent(moduleSsspGpioUp.gpio->port, moduleSsspGpioUp.gpio->pad, APAL2CH_EDGE(moduleSsspGpioUp.meta.edge));
+#endif
+#ifdef MODULE_INIT_INTERRUPTS
+  // further interrupt signals
+  MODULE_INIT_INTERRUPTS();
+#endif
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true)
-  // init shell
+  /* init shell */
   aosShellInit(&aos.shell,
                &aos.events.os,
                shellPrompt,
@@ -788,7 +797,7 @@ inline void aosSysStart(void)
     aos_timestamp_t t;
     aosSysGetUptimeX(&t);
     t = AMIROOS_CFG_SSSP_SYSSYNCPERIOD - (t % AMIROOS_CFG_SSSP_SYSSYNCPERIOD);
-    chVTSetI(&_syssynctimer, TIME_US2I((t > (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2)) ? (t - (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2)) : (t + (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2))), _sysSyncTimerCallback, NULL);
+    chVTSetI(&_syssynctimer, chTimeUS2I((t > (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2)) ? (t - (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2)) : (t + (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2))), _sysSyncTimerCallback, NULL);
     chSysUnlock();
   }
 #endif
@@ -865,7 +874,7 @@ inline void aosSysGetUptimeX(aos_timestamp_t* ut)
 {
   aosDbgCheck(ut != NULL);
 
-  *ut = _uptime + TIME_I2US(chVTGetSystemTimeX() - _synctime);
+  *ut = _uptime + chTimeI2US(chTimeDiffX(_synctime, chVTGetSystemTimeX()));
 
   return;
 }
@@ -987,17 +996,15 @@ void aosSysDeinit(void)
  * @brief   Finally shuts down the system and calls the bootloader callback function.
  * @note    This function should be called from the thtead with highest priority.
  *
- * @param[in] extDrv      Pointer to the interrupt driver.
  * @param[in] shutdown    Type of shutdown.
  */
-void aosSysShutdownFinal(aos_interrupt_driver_t* intDrv, aos_shutdown_t shutdown)
+void aosSysShutdownFinal(aos_shutdown_t shutdown)
 {
   // check arguments
-  aosDbgCheck(intDrv != NULL);
   aosDbgCheck(shutdown != AOS_SHUTDOWN_NONE);
 
-  // stop external interrupt system
-  aosIntDriverStop(intDrv);
+  // disable all interrupts
+  irqDeinit();
 
   // update the system SSSP stage
   aos.sssp.stage = AOS_SSSP_SHUTDOWN_1_3;
diff --git a/os/core/src/aos_thread.c b/os/core/src/aos_thread.c
index 768854b..5535e0f 100644
--- a/os/core/src/aos_thread.c
+++ b/os/core/src/aos_thread.c
@@ -34,13 +34,13 @@ void aosThdSleepUntilS(const aos_timestamp_t* t)
 
   // while the remaining time is too long, it must be split into multiple sleeps
   while ( (*t > uptime) && ((*t - uptime) > AOS_THD_MAX_SLEEP_US) ) {
-    chThdSleepS(TIME_US2I(AOS_THD_MAX_SLEEP_US));
+    chThdSleepS(chTimeUS2I(AOS_THD_MAX_SLEEP_US));
     aosSysGetUptimeX(&uptime);
   }
 
   // sleep the remaining time
   if (*t > uptime) {
-    systime_t rest = TIME_US2I(*t - uptime);
+    sysinterval_t rest = chTimeUS2I(*t - uptime);
     if (rest > TIME_IMMEDIATE) {
       chThdSleepS(rest);
     }
diff --git a/os/core/src/aos_timer.c b/os/core/src/aos_timer.c
index 531ec13..91e4982 100644
--- a/os/core/src/aos_timer.c
+++ b/os/core/src/aos_timer.c
@@ -45,9 +45,9 @@ static inline void _setupTimer(aos_timer_t* timer)
   if ( (timer->wkuptime > uptime) && ((timer->wkuptime - uptime) > TIME_IMMEDIATE) ) {
     // split the time delta if necessary
     if ((timer->wkuptime - uptime) > AOS_TIMER_MAX_INTERVAL_US) {
-      chVTSetI(&(timer->vt), TIME_US2I(AOS_TIMER_MAX_INTERVAL_US), _intermediateCb, timer);
+      chVTSetI(&(timer->vt), chTimeUS2I(AOS_TIMER_MAX_INTERVAL_US), _intermediateCb, timer);
     } else {
-      chVTSetI(&(timer->vt), TIME_US2I(timer->wkuptime - uptime), _fireCb, timer);
+      chVTSetI(&(timer->vt), chTimeUS2I(timer->wkuptime - uptime), _fireCb, timer);
     }
   } else {
     vtfunc_t fn = timer->callback;
diff --git a/os/unittests/lld/src/ut_lld_adc.c b/os/unittests/lld/src/ut_lld_adc.c
index dc5923f..05721f7 100644
--- a/os/unittests/lld/src/ut_lld_adc.c
+++ b/os/unittests/lld/src/ut_lld_adc.c
@@ -115,7 +115,7 @@ aos_utresult_t utAdcFunc(BaseSequentialStream* stream, aos_unittest_t* ut)
   conversionGroup.ltr = _adcWdgThreshold;
   _listener = chThdGetSelfX();
   adcStartConversion(((ut_adcdata_t*)(ut->data))->driver, &conversionGroup, buffer, 1);
-  eventmask = chEvtWaitOneTimeout(_adcWdgEventmask, TIME_S2I(5));
+  eventmask = chEvtWaitOneTimeout(_adcWdgEventmask, chTimeS2I(5));
   if (eventmask == _adcWdgEventmask) {
     aosUtPassedMsg(stream, &result, "%fV %c 9V\n", _adc2volt(buffer[0]), (buffer[0] > _adcWdgThreshold) ? '>' : '<');
     wdgpassed = true;
@@ -139,7 +139,7 @@ aos_utresult_t utAdcFunc(BaseSequentialStream* stream, aos_unittest_t* ut)
       aosThdMSleep(100); // wait some time so the ADC wil trigger again immediately due to noise
       _listener = chThdGetSelfX();
       adcStartConversion(((ut_adcdata_t*)(ut->data))->driver, &conversionGroup, buffer, 1);
-      eventmask = chEvtWaitOneTimeout(_adcWdgEventmask, TIME_S2I(10));
+      eventmask = chEvtWaitOneTimeout(_adcWdgEventmask, chTimeS2I(10));
       if (eventmask == _adcWdgEventmask) {
         aosUtPassedMsg(stream, &result, "%fV %c 9V\n", _adc2volt(buffer[0]), (buffer[0] > _adcWdgThreshold) ? '>' : '<');
       } else {
diff --git a/os/unittests/periphery-lld/src/ut_alld_hmc5883l.c b/os/unittests/periphery-lld/src/ut_alld_hmc5883l.c
index 17e1c34..eb4b7ca 100644
--- a/os/unittests/periphery-lld/src/ut_alld_hmc5883l.c
+++ b/os/unittests/periphery-lld/src/ut_alld_hmc5883l.c
@@ -159,7 +159,7 @@ aos_utresult_t utAlldHmc5883lFunc(BaseSequentialStream* stream, aos_unittest_t*
 
   chprintf(stream, "interrupt (full data read)...\n");
   status |= hmc5883l_lld_read_data(((ut_hmc5883ldata_t*)ut->data)->driver, mdata, ((ut_hmc5883ldata_t*)ut->data)->timeout);
-  event_mask = chEvtWaitOneTimeout(EVENT_MASK(0), TIME_US2I(100 * MICROSECONDS_PER_MILLISECOND));
+  event_mask = chEvtWaitOneTimeout(EVENT_MASK(0), chTimeUS2I(100 * MICROSECONDS_PER_MILLISECOND));
   chprintf(stream, "\t\teventmask = 0x%08X (should be 1)\n", event_mask);
   if (event_mask == EVENT_MASK(0)) {
     aosUtPassed(stream, &result);
@@ -176,7 +176,7 @@ aos_utresult_t utAlldHmc5883lFunc(BaseSequentialStream* stream, aos_unittest_t*
   aosSysGetUptime(&t);
   status |= hmc5883l_lld_read_data(((ut_hmc5883ldata_t*)ut->data)->driver, mdata, ((ut_hmc5883ldata_t*)ut->data)->timeout);
   while (t - start < MICROSECONDS_PER_SECOND) {
-    event_mask = chEvtWaitOneTimeout(EVENT_MASK(0), TIME_US2I(1000));
+    event_mask = chEvtWaitOneTimeout(EVENT_MASK(0), chTimeUS2I(1000));
     if (event_mask == EVENT_MASK(0)) {
       status |= hmc5883l_lld_read_data(((ut_hmc5883ldata_t*)ut->data)->driver, mdata, ((ut_hmc5883ldata_t*)ut->data)->timeout);
       data_reads++;
diff --git a/os/unittests/periphery-lld/src/ut_alld_lis331dlh.c b/os/unittests/periphery-lld/src/ut_alld_lis331dlh.c
index e10e06b..56378fa 100644
--- a/os/unittests/periphery-lld/src/ut_alld_lis331dlh.c
+++ b/os/unittests/periphery-lld/src/ut_alld_lis331dlh.c
@@ -219,6 +219,7 @@ aos_utresult_t utAlldLis331dlhFunc(BaseSequentialStream* stream, aos_unittest_t*
     }
     aosThdSSleep(1);
   }
+  event_mask = chEvtWaitOneTimeout(EVENT_MASK(3), TIME_IMMEDIATE);
   chEvtUnregister(((ut_lis331dlhdata_t*)(ut->data))->src, &el);
   if (status == APAL_STATUS_SUCCESS && success > 0) {
     aosUtPassed(stream, &result);
diff --git a/os/unittests/periphery-lld/src/ut_alld_mpr121.c b/os/unittests/periphery-lld/src/ut_alld_mpr121.c
index b8fdf11..2e5e30f 100644
--- a/os/unittests/periphery-lld/src/ut_alld_mpr121.c
+++ b/os/unittests/periphery-lld/src/ut_alld_mpr121.c
@@ -135,7 +135,7 @@ aos_utresult_t utAlldMpr121Func(BaseSequentialStream* stream, aos_unittest_t* ut
   do {
     aosSysGetUptime(&tcurrent);
     const aos_timestamp_t ttimeout = MICROSECONDS_PER_SECOND - ((tcurrent - tstart) % MICROSECONDS_PER_SECOND);
-    const eventmask_t emask = chEvtWaitOneTimeout(EVENT_MASK(INTERRUPT_EVENT_ID), TIME_US2I(ttimeout));
+    const eventmask_t emask = chEvtWaitOneTimeout(EVENT_MASK(INTERRUPT_EVENT_ID), chTimeUS2I(ttimeout));
     const eventflags_t eflags = chEvtGetAndClearFlags(&event_listener);
     if (emask == EVENT_MASK(INTERRUPT_EVENT_ID) && eflags == ((ut_mpr121data_t*)ut->data)->evtflags) {
       // interrupt detected
diff --git a/os/unittests/periphery-lld/src/ut_alld_vcnl4020.c b/os/unittests/periphery-lld/src/ut_alld_vcnl4020.c
index b33d967..fc3c674 100644
--- a/os/unittests/periphery-lld/src/ut_alld_vcnl4020.c
+++ b/os/unittests/periphery-lld/src/ut_alld_vcnl4020.c
@@ -169,7 +169,7 @@ aos_utresult_t utAlldVcnl4020Func(BaseSequentialStream* stream, aos_unittest_t*
   status |= vcnl4020_lld_writereg(((ut_vcnl4020data_t*)(ut->data))->vcnld, VCNL4020_LLD_REGADDR_INTCTRL, VCNL4020_LLD_INTCTRLREG_THRES_EN, ((ut_vcnl4020data_t*)(ut->data))->timeout);
   do {
     // read proximity data, interrupt event information and interrupt status
-    const eventmask_t emask = chEvtWaitOneTimeout(EVENT_MASK(INTERRUPT_EVENT_ID), TIME_US2I(10*MICROSECONDS_PER_MILLISECOND));
+    const eventmask_t emask = chEvtWaitOneTimeout(EVENT_MASK(INTERRUPT_EVENT_ID), chTimeUS2I(10*MICROSECONDS_PER_MILLISECOND));
     const eventflags_t eflags = chEvtGetAndClearFlags(&event_listener);
     status |= vcnl4020_lld_readprox(((ut_vcnl4020data_t*)(ut->data))->vcnld, &reg_16[0], ((ut_vcnl4020data_t*)(ut->data))->timeout);
     status |= vcnl4020_lld_readreg(((ut_vcnl4020data_t*)(ut->data))->vcnld, VCNL4020_LLD_REGADDR_INTSTATUS, &reg_8[2], ((ut_vcnl4020data_t*)(ut->data))->timeout);
diff --git a/periphery-lld/AMiRo-LLD b/periphery-lld/AMiRo-LLD
index 59c2837..cf1f756 160000
--- a/periphery-lld/AMiRo-LLD
+++ b/periphery-lld/AMiRo-LLD
@@ -1 +1 @@
-Subproject commit 59c2837266778acf1974df72318852ccb9d5e8bb
+Subproject commit cf1f756b0cb3a504a95343b00c436d93b82ef1a2
diff --git a/periphery-lld/periphAL.h b/periphery-lld/periphAL.h
index e00b0b3..9f3af14 100644
--- a/periphery-lld/periphAL.h
+++ b/periphery-lld/periphAL.h
@@ -56,12 +56,12 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 static inline void usleep(apalTime_t us)
 {
   // check if the specified time can be represented by the system
-  aosDbgCheck(us <= TIME_I2US(TIME_INFINITE));
+  aosDbgCheck(us <= chTimeI2US(TIME_INFINITE));
 
-  const systime_t st = TIME_US2I(us);
+  const sysinterval_t si = chTimeUS2I(us);
   // TIME_IMMEDIATE makes no sense and would even cause system halt
-  if (st != TIME_IMMEDIATE) {
-    chThdSleep(st);
+  if (si != TIME_IMMEDIATE) {
+    chThdSleep(si);
   }
   return;
 }
@@ -76,18 +76,8 @@ static inline void usleep(apalTime_t us)
  * @brief GPIO driver type.
  */
 struct apalGpio_t {
-  /*
-   * Workaround, since GPIOv2 (STM32F4XX) uses a different type than GPIOv1 (STM32F1XX).
-   */
-  #if defined(STM32F4XX)
-  stm32_gpio_t* port;
-  #elif defined(STM32F1XX)
-  GPIO_TypeDef* port;
-  #else
-  void* port;
-  #endif
-
-  uint8_t pad;
+  ioportid_t port;
+  iopadid_t pad;
 } PACKED_VAR;
 
 /**
@@ -183,16 +173,12 @@ static inline apalExitStatus_t apalControlGpioSet(const apalControlGpio_t* const
   return APAL_STATUS_OK;
 }
 
-#endif
-
-#if HAL_USE_PAL || defined(__DOXYGEN__)
-
 /**
- * @brief   Converts an apalGpioEdge_t to an ChibiOS EXT edge.
+ * @brief   Converts an apalGpioEdge_t to an ChibiOS PAL edge.
  */
-#define APAL2CH_EDGE(edge)                                        \
-  ((edge == APAL_GPIO_EDGE_RISING) ? PAL_EVENT_MODE_RISING_EDGE :    \
-    (edge == APAL_GPIO_EDGE_FALLING) ? PAL_EVENT_MODE_FALLING_EDGE : \
+#define APAL2CH_EDGE(edge)                                            \
+  ((edge == APAL_GPIO_EDGE_RISING) ? PAL_EVENT_MODE_RISING_EDGE :     \
+    (edge == APAL_GPIO_EDGE_FALLING) ? PAL_EVENT_MODE_FALLING_EDGE :  \
      (edge == APAL_GPIO_EDGE_BOTH) ? PAL_EVENT_MODE_BOTH_EDGES : 0)
 
 #endif
@@ -360,6 +346,8 @@ static inline apalExitStatus_t apalI2CMasterTransmit(apalI2CDriver_t* i2cd, cons
   i2cAcquireBus(i2cd);
 #endif
 
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wtype-limits"
 #if defined(STM32F1XX_I2C)
   // Due to a hardware limitation, for STM32F1 platform the minimum number of bytes that can be received is two.
   msg_t status = MSG_OK;
@@ -373,6 +361,7 @@ static inline apalExitStatus_t apalI2CMasterTransmit(apalI2CDriver_t* i2cd, cons
 #else
   const msg_t status = i2cMasterTransmitTimeout(i2cd, addr, txbuf, txbytes, rxbuf, rxbytes, ((timeout >= TIME_INFINITE) ? TIME_INFINITE : TIME_US2I(timeout)) );
 #endif
+#pragma GCC diagnostic pop
 
 #if (I2C_USE_MUTUAL_EXCLUSION == TRUE)
   i2cReleaseBus(i2cd);
@@ -413,6 +402,8 @@ static inline apalExitStatus_t apalI2CMasterReceive(apalI2CDriver_t* i2cd, const
   i2cAcquireBus(i2cd);
 #endif
 
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wtype-limits"
 #if defined(STM32F1XX_I2C)
   // Due to a hardware limitation, for STM32F1 platform the minimum number of bytes that can be received is two.
   msg_t status = MSG_OK;
@@ -426,6 +417,7 @@ static inline apalExitStatus_t apalI2CMasterReceive(apalI2CDriver_t* i2cd, const
 #else
   const msg_t status = i2cMasterReceiveTimeout(i2cd, addr, rxbuf, rxbytes, ((timeout >= TIME_INFINITE) ? TIME_INFINITE : TIME_US2I(timeout)) );
 #endif
+#pragma GCC diagnostic pop
 
 #if (I2C_USE_MUTUAL_EXCLUSION == TRUE)
   i2cReleaseBus(i2cd);
